diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/taxonomy.php ./wordpress-3.4/wp-includes/taxonomy.php
*** ./wordpress-3.3.2/wp-includes/taxonomy.php	2011-10-28 14:52:14.000000000 -0500
--- ./wordpress-3.4/wp-includes/taxonomy.php	2012-06-01 14:05:30.000000000 -0500
***************
*** 12,29 ****
  //
  
  /**
!  * Creates the initial taxonomies when 'init' action is fired.
   */
  function create_initial_taxonomies() {
  	global $wp_rewrite;
  
  	register_taxonomy( 'category', 'post', array(
  		'hierarchical' => true,
  		'query_var' => 'category_name',
! 		'rewrite' => did_action( 'init' ) ? array(
! 					'hierarchical' => true,
! 					'slug' => get_option('category_base') ? get_option('category_base') : 'category',
! 					'with_front' => ( get_option('category_base') && ! $wp_rewrite->using_index_permalinks() ) ? false : true ) : false,
  		'public' => true,
  		'show_ui' => true,
  		'_builtin' => true,
--- 12,50 ----
  //
  
  /**
!  * Creates the initial taxonomies.
!  *
!  * This function fires twice: in wp-settings.php before plugins are loaded (for
!  * backwards compatibility reasons), and again on the 'init' action. We must avoid
!  * registering rewrite rules before the 'init' action.
   */
  function create_initial_taxonomies() {
  	global $wp_rewrite;
  
+ 	if ( ! did_action( 'init' ) ) {
+ 		$rewrite = array( 'category' => false, 'post_tag' => false, 'post_format' => false );
+ 	} else {
+ 		$post_format_base = apply_filters( 'post_format_rewrite_base', 'type' );
+ 		$rewrite = array(
+ 			'category' => array(
+ 				'hierarchical' => true,
+ 				'slug' => get_option('category_base') ? get_option('category_base') : 'category',
+ 				'with_front' => ! get_option('category_base') || $wp_rewrite->using_index_permalinks(),
+ 				'ep_mask' => EP_CATEGORIES,
+ 			),
+ 			'post_tag' => array(
+ 				'slug' => get_option('tag_base') ? get_option('tag_base') : 'tag',
+ 				'with_front' => ! get_option('tag_base') || $wp_rewrite->using_index_permalinks(),
+ 				'ep_mask' => EP_TAGS,
+ 			),
+ 			'post_format' => $post_format_base ? array( 'slug' => $post_format_base ) : false,
+ 		);
+ 	}
+ 
  	register_taxonomy( 'category', 'post', array(
  		'hierarchical' => true,
  		'query_var' => 'category_name',
! 		'rewrite' => $rewrite['category'],
  		'public' => true,
  		'show_ui' => true,
  		'_builtin' => true,
***************
*** 32,40 ****
  	register_taxonomy( 'post_tag', 'post', array(
  	 	'hierarchical' => false,
  		'query_var' => 'tag',
! 		'rewrite' => did_action( 'init' ) ? array(
! 					'slug' => get_option('tag_base') ? get_option('tag_base') : 'tag',
! 					'with_front' => ( get_option('tag_base') && ! $wp_rewrite->using_index_permalinks() ) ? false : true ) : false,
  		'public' => true,
  		'show_ui' => true,
  		'_builtin' => true,
--- 53,59 ----
  	register_taxonomy( 'post_tag', 'post', array(
  	 	'hierarchical' => false,
  		'query_var' => 'tag',
! 		'rewrite' => $rewrite['post_tag'],
  		'public' => true,
  		'show_ui' => true,
  		'_builtin' => true,
***************
*** 77,88 ****
  		'_builtin' => true,
  	) );
  
- 	$rewrite = false;
- 	if ( did_action( 'init' ) ) {
- 		$rewrite = apply_filters( 'post_format_rewrite_base', 'type' );
- 		$rewrite = $rewrite ? array( 'slug' => $rewrite ) : false;
- 	}
- 
  	register_taxonomy( 'post_format', 'post', array(
  		'public' => true,
  		'hierarchical' => false,
--- 96,101 ----
***************
*** 91,100 ****
  			'singular_name' => _x( 'Format', 'post format' ),
  		),
  		'query_var' => true,
! 		'rewrite' => $rewrite,
  		'show_ui' => false,
  		'_builtin' => true,
! 		'show_in_nav_menus' => false,
  	) );
  }
  add_action( 'init', 'create_initial_taxonomies', 0 ); // highest priority
--- 104,113 ----
  			'singular_name' => _x( 'Format', 'post format' ),
  		),
  		'query_var' => true,
! 		'rewrite' => $rewrite['post_format'],
  		'show_ui' => false,
  		'_builtin' => true,
! 		'show_in_nav_menus' => current_theme_supports( 'post-formats' ),
  	) );
  }
  add_action( 'init', 'create_initial_taxonomies', 0 ); // highest priority
***************
*** 284,290 ****
   * @subpackage Taxonomy
   * @since 2.3.0
   * @uses $wp_taxonomies Inserts new taxonomy object into the list
-  * @uses $wp_rewrite Adds rewrite tags and permastructs
   * @uses $wp Adds query vars
   *
   * @param string $taxonomy Name of taxonomy object
--- 296,301 ----
***************
*** 292,298 ****
   * @param array|string $args See above description for the two keys values.
   */
  function register_taxonomy( $taxonomy, $object_type, $args = array() ) {
! 	global $wp_taxonomies, $wp_rewrite, $wp;
  
  	if ( ! is_array($wp_taxonomies) )
  		$wp_taxonomies = array();
--- 303,309 ----
   * @param array|string $args See above description for the two keys values.
   */
  function register_taxonomy( $taxonomy, $object_type, $args = array() ) {
! 	global $wp_taxonomies, $wp;
  
  	if ( ! is_array($wp_taxonomies) )
  		$wp_taxonomies = array();
***************
*** 318,328 ****
  		$wp->add_query_var($args['query_var']);
  	}
  
! 	if ( false !== $args['rewrite'] && '' != get_option('permalink_structure') ) {
  		$args['rewrite'] = wp_parse_args($args['rewrite'], array(
  			'slug' => sanitize_title_with_dashes($taxonomy),
  			'with_front' => true,
! 			'hierarchical' => false
  		));
  
  		if ( $args['hierarchical'] && $args['rewrite']['hierarchical'] )
--- 329,340 ----
  		$wp->add_query_var($args['query_var']);
  	}
  
! 	if ( false !== $args['rewrite'] && ( is_admin() || '' != get_option('permalink_structure') ) ) {
  		$args['rewrite'] = wp_parse_args($args['rewrite'], array(
  			'slug' => sanitize_title_with_dashes($taxonomy),
  			'with_front' => true,
! 			'hierarchical' => false,
! 			'ep_mask' => EP_NONE,
  		));
  
  		if ( $args['hierarchical'] && $args['rewrite']['hierarchical'] )
***************
*** 330,337 ****
  		else
  			$tag = '([^/]+)';
  
! 		$wp_rewrite->add_rewrite_tag("%$taxonomy%", $tag, $args['query_var'] ? "{$args['query_var']}=" : "taxonomy=$taxonomy&term=");
! 		$wp_rewrite->add_permastruct($taxonomy, "{$args['rewrite']['slug']}/%$taxonomy%", $args['rewrite']['with_front']);
  	}
  
  	if ( is_null($args['show_ui']) )
--- 342,349 ----
  		else
  			$tag = '([^/]+)';
  
! 		add_rewrite_tag( "%$taxonomy%", $tag, $args['query_var'] ? "{$args['query_var']}=" : "taxonomy=$taxonomy&term=" );
! 		add_permastruct( $taxonomy, "{$args['rewrite']['slug']}/%$taxonomy%", $args['rewrite'] );
  	}
  
  	if ( is_null($args['show_ui']) )
***************
*** 379,392 ****
   * - parent_item - This string isn't used on non-hierarchical taxonomies. In hierarchical ones the default is Parent Category
   * - parent_item_colon - The same as <code>parent_item</code>, but with colon <code>:</code> in the end
   * - edit_item - Default is Edit Tag/Edit Category
   * - update_item - Default is Update Tag/Update Category
   * - add_new_item - Default is Add New Tag/Add New Category
   * - new_item_name - Default is New Tag Name/New Category Name
!  * - separate_items_with_commas - This string isn't used on hierarchical taxonomies. Default is "Separate tags with commas," used in the meta box.
!  * - add_or_remove_items - This string isn't used on hierarchical taxonomies. Default is "Add or remove tags," used in the meta box when JavaScript is disabled.
!  * - choose_from_most_used - This string isn't used on hierarchical taxonomies. Default is "Choose from the most used tags," used in the meta box.
   *
!  * Above, the first default value is for non-hierarchical taxonomies (like tags) and the second one is for hierarchical taxonomies (like categories.)
   *
   * @since 3.0.0
   * @param object $tax Taxonomy object
--- 391,405 ----
   * - parent_item - This string isn't used on non-hierarchical taxonomies. In hierarchical ones the default is Parent Category
   * - parent_item_colon - The same as <code>parent_item</code>, but with colon <code>:</code> in the end
   * - edit_item - Default is Edit Tag/Edit Category
+  * - view_item - Default is View Tag/View Category
   * - update_item - Default is Update Tag/Update Category
   * - add_new_item - Default is Add New Tag/Add New Category
   * - new_item_name - Default is New Tag Name/New Category Name
!  * - separate_items_with_commas - This string isn't used on hierarchical taxonomies. Default is "Separate tags with commas", used in the meta box.
!  * - add_or_remove_items - This string isn't used on hierarchical taxonomies. Default is "Add or remove tags", used in the meta box when JavaScript is disabled.
!  * - choose_from_most_used - This string isn't used on hierarchical taxonomies. Default is "Choose from the most used tags", used in the meta box.
   *
!  * Above, the first default value is for non-hierarchical taxonomies (like tags) and the second one is for hierarchical taxonomies (like categories).
   *
   * @since 3.0.0
   * @param object $tax Taxonomy object
***************
*** 428,434 ****
   * @uses $wp_taxonomies Modifies taxonomy object
   *
   * @param string $taxonomy Name of taxonomy object
!  * @param array|string $object_type Name of the object type
   * @return bool True if successful, false if not
   */
  function register_taxonomy_for_object_type( $taxonomy, $object_type) {
--- 441,447 ----
   * @uses $wp_taxonomies Modifies taxonomy object
   *
   * @param string $taxonomy Name of taxonomy object
!  * @param string $object_type Name of the object type
   * @return bool True if successful, false if not
   */
  function register_taxonomy_for_object_type( $taxonomy, $object_type) {
***************
*** 489,495 ****
  
  	foreach ( (array) $taxonomies as $taxonomy ) {
  		if ( ! taxonomy_exists( $taxonomy ) )
! 			return new WP_Error( 'invalid_taxonomy', __( 'Invalid Taxonomy' ) );
  	}
  
  	$defaults = array( 'order' => 'ASC' );
--- 502,508 ----
  
  	foreach ( (array) $taxonomies as $taxonomy ) {
  		if ( ! taxonomy_exists( $taxonomy ) )
! 			return new WP_Error( 'invalid_taxonomy', __( 'Invalid taxonomy' ) );
  	}
  
  	$defaults = array( 'order' => 'ASC' );
***************
*** 842,848 ****
  	}
  
  	if ( ! taxonomy_exists($taxonomy) ) {
! 		$error = new WP_Error('invalid_taxonomy', __('Invalid Taxonomy'));
  		return $error;
  	}
  
--- 855,861 ----
  	}
  
  	if ( ! taxonomy_exists($taxonomy) ) {
! 		$error = new WP_Error('invalid_taxonomy', __('Invalid taxonomy'));
  		return $error;
  	}
  
***************
*** 971,977 ****
   */
  function get_term_children( $term_id, $taxonomy ) {
  	if ( ! taxonomy_exists($taxonomy) )
! 		return new WP_Error('invalid_taxonomy', __('Invalid Taxonomy'));
  
  	$term_id = intval( $term_id );
  
--- 984,990 ----
   */
  function get_term_children( $term_id, $taxonomy ) {
  	if ( ! taxonomy_exists($taxonomy) )
! 		return new WP_Error('invalid_taxonomy', __('Invalid taxonomy'));
  
  	$term_id = intval( $term_id );
  
***************
*** 1083,1101 ****
   * hide_empty - Default is true. Will not return empty terms, which means
   * terms whose count is 0 according to the given taxonomy.
   *
!  * exclude - Default is an empty array.  An array, comma- or space-delimited string
!  * of term ids to exclude from the return array.  If 'include' is non-empty,
   * 'exclude' is ignored.
   *
!  * exclude_tree - Default is an empty array.  An array, comma- or space-delimited
   * string of term ids to exclude from the return array, along with all of their
!  * descendant terms according to the primary taxonomy.  If 'include' is non-empty,
   * 'exclude_tree' is ignored.
   *
!  * include - Default is an empty array.  An array, comma- or space-delimited string
   * of term ids to include in the return array.
   *
!  * number - The maximum number of terms to return.  Default is to return them all.
   *
   * offset - The number by which to offset the terms query.
   *
--- 1096,1114 ----
   * hide_empty - Default is true. Will not return empty terms, which means
   * terms whose count is 0 according to the given taxonomy.
   *
!  * exclude - Default is an empty array. An array, comma- or space-delimited string
!  * of term ids to exclude from the return array. If 'include' is non-empty,
   * 'exclude' is ignored.
   *
!  * exclude_tree - Default is an empty array. An array, comma- or space-delimited
   * string of term ids to exclude from the return array, along with all of their
!  * descendant terms according to the primary taxonomy. If 'include' is non-empty,
   * 'exclude_tree' is ignored.
   *
!  * include - Default is an empty array. An array, comma- or space-delimited string
   * of term ids to include in the return array.
   *
!  * number - The maximum number of terms to return. Default is to return them all.
   *
   * offset - The number by which to offset the terms query.
   *
***************
*** 1109,1115 ****
   * (even if 'hide_empty' is set to true).
   *
   * search - Returned terms' names will contain the value of 'search',
!  * case-insensitive.  Default is an empty string.
   *
   * name__like - Returned terms' names will begin with the value of 'name__like',
   * case-insensitive. Default is empty string.
--- 1122,1128 ----
   * (even if 'hide_empty' is set to true).
   *
   * search - Returned terms' names will contain the value of 'search',
!  * case-insensitive. Default is an empty string.
   *
   * name__like - Returned terms' names will begin with the value of 'name__like',
   * case-insensitive. Default is empty string.
***************
*** 1120,1132 ****
   * The 'get' argument, if set to 'all' instead of its default empty string,
   * returns terms regardless of ancestry or whether the terms are empty.
   *
!  * The 'child_of' argument, when used, should be set to the integer of a term ID.  Its default
!  * is 0.  If set to a non-zero value, all returned terms will be descendants
!  * of that term according to the given taxonomy.  Hence 'child_of' is set to 0
   * if more than one taxonomy is passed in $taxonomies, because multiple taxonomies
   * make term ancestry ambiguous.
   *
!  * The 'parent' argument, when used, should be set to the integer of a term ID.  Its default is
   * the empty string '', which has a different meaning from the integer 0.
   * If set to an integer value, all returned terms will have as an immediate
   * ancestor the term whose ID is specified by that integer according to the given taxonomy.
--- 1133,1145 ----
   * The 'get' argument, if set to 'all' instead of its default empty string,
   * returns terms regardless of ancestry or whether the terms are empty.
   *
!  * The 'child_of' argument, when used, should be set to the integer of a term ID. Its default
!  * is 0. If set to a non-zero value, all returned terms will be descendants
!  * of that term according to the given taxonomy. Hence 'child_of' is set to 0
   * if more than one taxonomy is passed in $taxonomies, because multiple taxonomies
   * make term ancestry ambiguous.
   *
!  * The 'parent' argument, when used, should be set to the integer of a term ID. Its default is
   * the empty string '', which has a different meaning from the integer 0.
   * If set to an integer value, all returned terms will have as an immediate
   * ancestor the term whose ID is specified by that integer according to the given taxonomy.
***************
*** 1161,1167 ****
  
  	foreach ( $taxonomies as $taxonomy ) {
  		if ( ! taxonomy_exists($taxonomy) ) {
! 			$error = new WP_Error('invalid_taxonomy', __('Invalid Taxonomy'));
  			return $error;
  		}
  	}
--- 1174,1180 ----
  
  	foreach ( $taxonomies as $taxonomy ) {
  		if ( ! taxonomy_exists($taxonomy) ) {
! 			$error = new WP_Error('invalid_taxonomy', __('Invalid taxonomy'));
  			return $error;
  		}
  	}
***************
*** 1431,1438 ****
  /**
   * Check if Term exists.
   *
-  * Returns the index of a defined term, or 0 (false) if the term doesn't exist.
-  *
   * Formerly is_term(), introduced in 2.3.0.
   *
   * @package WordPress
--- 1444,1449 ----
***************
*** 1444,1450 ****
   * @param int|string $term The term to check
   * @param string $taxonomy The taxonomy name to use
   * @param int $parent ID of parent term under which to confine the exists search.
!  * @return mixed Get the term id or Term Object, if exists.
   */
  function term_exists($term, $taxonomy = '', $parent = 0) {
  	global $wpdb;
--- 1455,1462 ----
   * @param int|string $term The term to check
   * @param string $taxonomy The taxonomy name to use
   * @param int $parent ID of parent term under which to confine the exists search.
!  * @return mixed Returns 0 if the term does not exist. Returns the term ID if no taxonomy is specified
!  * 	and the term ID exists. Returns an array of the term ID and the taxonomy if the pairing exists.
   */
  function term_exists($term, $taxonomy = '', $parent = 0) {
  	global $wpdb;
***************
*** 1496,1501 ****
--- 1508,1539 ----
  }
  
  /**
+  * Check if a term is an ancestor of another term.
+  *
+  * You can use either an id or the term object for both parameters.
+  *
+  * @since 3.4.0
+  *
+  * @param int|object $term1 ID or object to check if this is the parent term.
+  * @param int|object $term2 The child term.
+  * @param string $taxonomy Taxonomy name that $term1 and $term2 belong to.
+  * @return bool Whether $term2 is child of $term1
+  */
+ function term_is_ancestor_of( $term1, $term2, $taxonomy ) {
+ 	if ( ! isset( $term1->term_id ) )
+ 		$term1 = get_term( $term1, $taxonomy );
+ 	if ( ! isset( $term2->parent ) )
+ 		$term2 = get_term( $term2, $taxonomy );
+ 
+ 	if ( empty( $term1->term_id ) || empty( $term2->parent ) )
+ 		return false;
+ 	if ( $term2->parent == $term1->term_id )
+ 		return true;
+ 
+ 	return term_is_ancestor_of( $term1, get_term( $term2->parent, $taxonomy ), $taxonomy );
+ }
+ 
+ /**
   * Sanitize Term all fields.
   *
   * Relies on sanitize_term_field() to sanitize the term. The difference is that
***************
*** 1765,1776 ****
  		clean_object_term_cache( $objects, $object_type );
  
  	do_action( 'delete_term_taxonomy', $tt_id );
! 	$wpdb->query( $wpdb->prepare( "DELETE FROM $wpdb->term_taxonomy WHERE term_taxonomy_id = %d", $tt_id ) );
  	do_action( 'deleted_term_taxonomy', $tt_id );
  
  	// Delete the term if no taxonomies use it.
  	if ( !$wpdb->get_var( $wpdb->prepare( "SELECT COUNT(*) FROM $wpdb->term_taxonomy WHERE term_id = %d", $term) ) )
! 		$wpdb->query( $wpdb->prepare( "DELETE FROM $wpdb->terms WHERE term_id = %d", $term) );
  
  	clean_term_cache($term, $taxonomy);
  
--- 1803,1814 ----
  		clean_object_term_cache( $objects, $object_type );
  
  	do_action( 'delete_term_taxonomy', $tt_id );
! 	$wpdb->delete( $wpdb->term_taxonomy, array( 'term_taxonomy_id' => $tt_id ) );
  	do_action( 'deleted_term_taxonomy', $tt_id );
  
  	// Delete the term if no taxonomies use it.
  	if ( !$wpdb->get_var( $wpdb->prepare( "SELECT COUNT(*) FROM $wpdb->term_taxonomy WHERE term_id = %d", $term) ) )
! 		$wpdb->delete( $wpdb->terms, array( 'term_id' => $term ) );
  
  	clean_term_cache($term, $taxonomy);
  
***************
*** 1824,1840 ****
   * @param int|array $object_ids The ID(s) of the object(s) to retrieve.
   * @param string|array $taxonomies The taxonomies to retrieve terms from.
   * @param array|string $args Change what is returned
!  * @return array|WP_Error The requested term data or empty array if no terms found. WP_Error if $taxonomy does not exist.
   */
  function wp_get_object_terms($object_ids, $taxonomies, $args = array()) {
  	global $wpdb;
  
  	if ( !is_array($taxonomies) )
  		$taxonomies = array($taxonomies);
  
  	foreach ( (array) $taxonomies as $taxonomy ) {
  		if ( ! taxonomy_exists($taxonomy) )
! 			return new WP_Error('invalid_taxonomy', __('Invalid Taxonomy'));
  	}
  
  	if ( !is_array($object_ids) )
--- 1862,1881 ----
   * @param int|array $object_ids The ID(s) of the object(s) to retrieve.
   * @param string|array $taxonomies The taxonomies to retrieve terms from.
   * @param array|string $args Change what is returned
!  * @return array|WP_Error The requested term data or empty array if no terms found. WP_Error if any of the $taxonomies don't exist.
   */
  function wp_get_object_terms($object_ids, $taxonomies, $args = array()) {
  	global $wpdb;
  
+ 	if ( empty( $object_ids ) || empty( $taxonomies ) )
+ 		return array();
+ 
  	if ( !is_array($taxonomies) )
  		$taxonomies = array($taxonomies);
  
  	foreach ( (array) $taxonomies as $taxonomy ) {
  		if ( ! taxonomy_exists($taxonomy) )
! 			return new WP_Error('invalid_taxonomy', __('Invalid taxonomy'));
  	}
  
  	if ( !is_array($object_ids) )
***************
*** 2105,2111 ****
  	$object_id = (int) $object_id;
  
  	if ( ! taxonomy_exists($taxonomy) )
! 		return new WP_Error('invalid_taxonomy', __('Invalid Taxonomy'));
  
  	if ( !is_array($terms) )
  		$terms = array($terms);
--- 2146,2152 ----
  	$object_id = (int) $object_id;
  
  	if ( ! taxonomy_exists($taxonomy) )
! 		return new WP_Error('invalid_taxonomy', __('Invalid taxonomy'));
  
  	if ( !is_array($terms) )
  		$terms = array($terms);
***************
*** 2637,2643 ****
  		$object_terms[$term->object_id][$term->taxonomy][$term->term_id] = $term;
  
  	foreach ( $ids as $id ) {
! 		foreach ( $taxonomies  as $taxonomy ) {
  			if ( ! isset($object_terms[$id][$taxonomy]) ) {
  				if ( !isset($object_terms[$id]) )
  					$object_terms[$id] = array();
--- 2674,2680 ----
  		$object_terms[$term->object_id][$term->taxonomy][$term->term_id] = $term;
  
  	foreach ( $ids as $id ) {
! 		foreach ( $taxonomies as $taxonomy ) {
  			if ( ! isset($object_terms[$id][$taxonomy]) ) {
  				if ( !isset($object_terms[$id]) )
  					$object_terms[$id] = array();
***************
*** 2648,2654 ****
  
  	foreach ( $object_terms as $id => $value ) {
  		foreach ( $value as $taxonomy => $terms ) {
! 			wp_cache_set($id, $terms, "{$taxonomy}_relationships");
  		}
  	}
  }
--- 2685,2691 ----
  
  	foreach ( $object_terms as $id => $value ) {
  		foreach ( $value as $taxonomy => $terms ) {
! 			wp_cache_add( $id, $terms, "{$taxonomy}_relationships" );
  		}
  	}
  }
***************
*** 3094,3100 ****
   *
   * @param int $object_id ID of the object (post ID, link ID, ...)
   * @param string $taxonomy Single taxonomy name
!  * @param int|string|array $terms Optional.  Term term_id, name, slug or array of said
   * @return bool|WP_Error. WP_Error on input error.
   */
  function is_object_in_term( $object_id, $taxonomy, $terms = null ) {
--- 3126,3132 ----
   *
   * @param int $object_id ID of the object (post ID, link ID, ...)
   * @param string $taxonomy Single taxonomy name
!  * @param int|string|array $terms Optional. Term term_id, name, slug or array of said
   * @return bool|WP_Error. WP_Error on input error.
   */
  function is_object_in_term( $object_id, $taxonomy, $terms = null ) {
***************
*** 3240,3246 ****
  	if ( isset( $loop[$term_id] ) )
  		return 0;
  
! 	// There's a loop, but it doesn't contain $term_id.  Break the loop.
  	foreach ( array_keys( $loop ) as $loop_member )
  		wp_update_term( $loop_member, $taxonomy, array( 'parent' => 0 ) );
  
--- 3272,3278 ----
  	if ( isset( $loop[$term_id] ) )
  		return 0;
  
! 	// There's a loop, but it doesn't contain $term_id. Break the loop.
  	foreach ( array_keys( $loop ) as $loop_member )
  		wp_update_term( $loop_member, $taxonomy, array( 'parent' => 0 ) );
  
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/template-loader.php ./wordpress-3.4/wp-includes/template-loader.php
*** ./wordpress-3.3.2/wp-includes/template-loader.php	2010-04-28 02:48:09.000000000 -0500
--- ./wordpress-3.4/wp-includes/template-loader.php	2012-01-08 11:01:11.000000000 -0600
***************
*** 43,47 ****
  		include( $template );
  	return;
  endif;
- 
- ?>
--- 43,45 ----
